//Author: George Koutsogiannakis
//Date: 8/31/02

/** 
&author George Koutsogiannakis
*/
package com.neurowebtech.koutsogiannakis;

import javax.swing.JOptionPane;
import javax.swing.JApplet;
import javax.swing.*;
import java.text.DecimalFormat;
import java.awt.Graphics;
import java.awt.*;
import java.awt.event.*;


public class Mortgagecalculation extends JApplet implements Runnable
{

	/** 
	@param interest This parameter defines the interest that the user enters in a GUI component in two decimal places as a String
	@param interestnumber This is the double type version of the interest parameter.
	@param time This is the number of months that the user enters as a duration for the loan as a String
	@param timenumber This is the double version of the number of months entered.
	@param loanamount This is the amount of laon entered in the GUI by the user as a String.
	@param loannumber This is the converted laonamount String into a double.
	*/
	String interest;
	double interestnumber;
	String time;
    String loanamount;
	String result;
	String string;
	double timenumber;
	double decimalinterestnumber;
	double loannumber;
	double payment;
	double z;
	double x;
	double a;
	double y;
	double totalpayments;
	double totalinterest;
	DecimalFormat twodigits = new DecimalFormat("0.00");

	/** This method is just the default implementation of the init method for the applet. */
	public void init()
	{
		
	}

		
	
		
	/** This method is overriden and provides the GUI and associated listeners */

	public void start ()
	{
		Mortgagecalculation m=new Mortgagecalculation();
		//2=information message
		
		interest = JOptionPane.showInputDialog (m, "Enter the annual interest rate with up to three decimal places", "	REQUEST FROM USER", 2);
		interestnumber = Double.parseDouble(interest);
		time= JOptionPane.showInputDialog (this, "Enter the time in months");
		timenumber = Double.parseDouble(time);
		loanamount=JOptionPane.showInputDialog (m, "Enter the amount of the loan");
		loannumber=Double.parseDouble(loanamount);
		 
		decimalinterestnumber=interestnumber*0.01;
		System.out.println(decimalinterestnumber);
		z= decimalinterestnumber/12;
		a= (1+z);
		System.out.println(a);
		x= Math.pow( a, timenumber);
		System.out.println(timenumber);
		System.out.println(x);
		y=  1- (1/x);
		payment= (loannumber*z) / y;
		System.out.println(payment);
		//Format the payment number two a two digit format to the right of the decimal point.
		//Class decimalFormat belongs to package java.text
		
		result="Your montly payment is:"+" "+"$"+" "+twodigits.format(payment);
		JOptionPane.showMessageDialog(this, result , "MONTLY PAYMENT" , JOptionPane.INFORMATION_MESSAGE); 
		
		Container c= getContentPane();
		// Create a Canvas
		Canvas canvas =new Canvas();
		c.setLayout(new BorderLayout(5,5));
		c.add (canvas, BorderLayout.NORTH);

		//Create a text Area to output more information in string
		string="If you would like to exit this program click on the exit button,\n"+
			"if you would like to enter new numbers clickon the continue button";
		JTextArea textarea = new JTextArea(string, 25, 15);
		//USE "BOX LAYOUT MANAGER" TO ARRANGE COMPONENETS LEFT TO RIGHT WITHIN THE CONTAINER. 
		//THE CONTAINER IS THE TEXT AREA IN THIS CASE.
		
		
		Box box =Box.createHorizontalBox();
		box.add(new JScrollPane (textarea));
		JButton exit=new JButton ("Exit");
		box.add(exit);
		JButton contin =new JButton ("Continue");
		box.add(contin);
		c.add(box, BorderLayout.SOUTH);
		exit.addActionListener( new ActionListener() {
				public void actionPerformed (ActionEvent e)
				{
					destroy();
				}
			} //end anonymous inner class
		); // end call to ActionListener
		
		contin.addActionListener( new ActionListener() {
				public void actionPerformed (ActionEvent e)
				{
					start();
				}
			} //end anonymous inner class
		); // end call to ActionListener
		repaint();
	}

	/** This method will work only if the proper policy and or certificate hav ebeen issued */

	public void destroy ()
	{
		System.exit(0);
	}

	/** This method diplays the calculated montly payment. */
	public void run()

	{
		result="This is your montly mortgage payment:"+" "+payment;
		JOptionPane.showMessageDialog(this, result , "MONTLY PAYMENT" , JOptionPane.INFORMATION_MESSAGE); 
		
	}

    /** This method is calle dwhen repaint is called. It draws on the applet pane certain information about the loan. */
	public void paint (Graphics g)
	{
		super.paint(g);
		totalpayments=timenumber*payment;
		totalinterest = totalpayments-loannumber;
		g.drawString("The total payments made are:"+" " + twodigits.format(totalpayments) , 25, 25);
		g.drawString("The total interest paid is:"+" " + twodigits.format(totalinterest) , 25, 50);
		
	}

	
}
